////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Copyright (c) Microsoft Corporation.  All rights reserved.
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "tinyhal.h"

//--//

void HeapLocation( UINT8*& BaseAddress, UINT32& SizeInBytes )
{
    NATIVE_PROFILE_PAL_HEAP();
#if defined (PLATFORM_ARM) || defined(PLATFORM_SH) || defined(PLATFORM_RX)

     BaseAddress = (UINT8*)                            &HeapBegin;
     SizeInBytes = (UINT32)((size_t)&HeapEnd - (size_t)&HeapBegin + sizeof(HeapEnd));

#else

    BaseAddress = 0;
    SizeInBytes = 0;
    
#endif
 
}

